Description: Language teachers often quote a paragraph and then make several multiple choice questions related to it. It 

is important that the paragraph and the following questions come in a fixed sequence. I can put quoted text in 
a box in a minipage, for example like this:

Questions 1

A
B
C
D
 boxed minipage with quoted text

Question 2

A
B
C
D

Question 3

A B C D

In this scenario, boxed minipage with quoted text is actually referred to in Questions 2 and 3, although 
AMC-TXT sees the minipage as part of the choice D in Question 1.

For this scenario to work, I need to be able to define Questions 1,2 and 3 as appearing in a fixed sequence. 
However I would like to be able to shuffle other questions in the exam freely. Is there a way to do this in 
AMC-TXT?

For example, I was thinking of defining a new option for questions:

<pre>
*[fixed] This is a second question. This question will appear as a second question regardless of 
ShuffleQuestions:1.
+
-
-
-
</pre>
Even better, one would be able to define a sequence of questions to be shuffled as a block.

For example:
<pre>
*[block1] Question1 This question can be shuffled in the exam but it would always end up
                    preceding Question2.
+
-
-
+

**[block1] Question2 This question can be shuffled in the exam but it would always finish in
                     a position directly after Question1.
-
+
+
+
</pre>
Then one could define different blocks/groups of questions [block2],[block3], etc.

Thanks for your hard work,

Niko Z.

History
08/01/2013 12:41 pm - Nikola Z. Guscic
The @[block1]@ and @[block2]@,@[block3]@...) would preserve the blocked sequence of questions throughout the shuffling process, but blocks 
would still be moved.

Another option that I meant to propose in the original post would be @[fixed]@. A question with @[fixed]@ option would stay in place throughout the 
shuffling process. This might be useful for essay questions, many teachers prefer to write them in a defined sequence at the end of the exam. For 
example,

@*[fixed] Question 2 will appear as a second question regardless of shuffling@
@-@
@+@
@-@ 

So in the end, this issue is actually about implementing two distinct (but related) features.

Thanks,

Niko Z.

08/01/2013 12:41 pm - Nikola Z. Guscic
The @[block1]@ and @[block2]@,@[block3]@...) would preserve the blocked sequence of questions throughout the shuffling process, but blocks 
would still be moved.

Another option that I meant to propose in the original post would be @[fixed]@. A question with @[fixed]@ option would stay in place throughout the 
shuffling process. This might be useful for essay questions, many teachers prefer to write them in a defined sequence at the end of the exam. For 
example,

@*[fixed] Question 2 will appear as a second question regardless of shuffling@
@-@
@+@
@-@ 

So in the end, this issue is actually about implementing two distinct (but related) features.

Thanks,
Niko Z.

08/01/2013 07:09 pm - Alexis Bienvenüe
From revision r1408, you can use the @next@ question option, that sticks the question always after to the previous one.
This is not yet the _groups_ implementation, but I thought it could be usefull in some simple cases.

08/01/2013 07:10 pm - Alexis Bienvenüe
- Description changed from Language teachers often quote a paragraph and then make several multiple choice questions related to it. It is important 
that the paragraph and the following questions come in a fixed sequence. I can put quoted text in a box in a minipage, for example like this:

Questions 1

A
B
C
D
 boxed minipage with quoted text

Question 2

A
B
C
D

Question 3

A B C D

In this scenario, boxed minipage with quoted text is actually referred to in Questions 2 and 3, although AMC-TXT sees the minipage as part of the 
choice D in Question 1.

For this scenario to work, I need to be able to define Questions 1,2 and 3 as appearing in a fixed sequence. However I would like to be able to shuffle 
other questions in the exam freely. Is there a way to do this in AMC-TXT?

For example, I was thinking of defining a new option for questions:

*[fixed] This is a second question. This question will appear as a second question regardless of ShuffleQuestions:1.
+
-
-
-

Even better, one would be able to define a sequence of questions to be shuffled as a block.

For example:

*[block1] Question1 This question can be shuffled in the exam but it would always end up
                    preceding Question2.
+
-
-
+

**[block1] Question2 This question can be shuffled in the exam but it would always finish in
                     a position directly after Question1.
-
+
+
+

Then one could define different blocks/groups of questions [block2],[block3], etc.

Thanks for your hard work,

Niko Z. to Language teachers often quote a paragraph and then make several multiple choice questions related to it. It is important that the paragraph 
and the following questions come in a fixed sequence. I can put quoted text in a box in a minipage, for example like this:

Questions 1

A
B
C
D
 boxed minipage with quoted text

Question 2

A
B
C
D

Question 3

A B C D

In this scenario, boxed minipage with quoted text is actually referred to in Questions 2 and 3, although AMC-TXT sees the minipage as part of the 
choice D in Question 1.

For this scenario to work, I need to be able to define Questions 1,2 and 3 as appearing in a fixed sequence. However I would like to be able to shuffle 
other questions in the exam freely. Is there a way to do this in AMC-TXT?

For example, I was thinking of defining a new option for questions:

<pre>
*[fixed] This is a second question. This question will appear as a second question regardless of ShuffleQuestions:1.
+
-
-
-
</pre>
Even better, one would be able to define a sequence of questions to be shuffled as a block.

For example:
<pre>
*[block1] Question1 This question can be shuffled in the exam but it would always end up
                    preceding Question2.
+
-
-
+

**[block1] Question2 This question can be shuffled in the exam but it would always finish in
                     a position directly after Question1.
-
+
+
+
</pre>
Then one could define different blocks/groups of questions [block2],[block3], etc.

Thanks for your hard work,

Niko Z.

08/04/2013 01:23 pm - Nikola Z. Guscic
This looks very useful already. I've tried it with various combinations of text boxes and included graphics and it places questions properly without leaving 
odd spaces on the page. I will create and grade an exam using this option on Monday/Tuesday and let you know if anything unusual comes up.

This is really a great help for our teachers. With this feature added they have a set of tools they need to create many types of exams in AMC-TXT.

Many thanks,

Niko Z.

08/10/2013 03:55 pm - Alexis Bienvenüe
Also, from revision r1414, you can use something like that:
<pre>
*( Introductory text

* Question 1
-
-
+

* Question 2
-
-
+

*) Closing text.

08/11/2013 10:09 am - Nikola Z. Guscic
Excellent! If we combine this with @[next]@ option for questions enclosed within brackets we get a fine control of which questions within a block get 
shuffled and which come in a sequence. Simple syntax but very effective, provides a lot of options for the text maker, exactly what was needed. 
I've tried this with text boxes within minipages and various positions of pictures next to/above/below text/textboxes, everything displayed properly.

It seems that by default introductory and closing text (text box/framed box/minipage) always get flushed left. So, for example if I want to display quoted 
paragraph in a framed box placed in a center of a page (which comes up often in language exams) I have to position it manually using @\hspace@. 
Centering options in LaTex don't seem to work for minipages in AMC-TXT (at least the ones I know, which are not that many :). This is not a big problem 
in itself and I don't mean to be nitpicky, just thought I might mention that for future reference. Presently, if we change the size of paper we have to reset 
all horizontal spaces. It might be nice to have a code available for that at some point.

Anyway, that very minor point aside, thank you so much for creating @[next]@ and the 'Introductory/closing text' options. This really resolves the main 
point of this issue. Moreover, it seems that my original post was too broadly framed as it was really several issues rolled in one. So far you've already 
created two new features to address the issue. Perhaps it might be better to consider the present issue successfully resolved and I could open a 
separate one for implementing @groups@ (to help teachers who wish to append essay questions at the end of (shuffled) multiple choice questions). 
That way it might be easier to keep track and focus.

Best,

Niko Z.

08/11/2013 10:44 am - Nikola Z. Guscic
Oh, just one thing that I just noticed. Combining @[next]@ and @*( Introductory text@ works very well, except if we want to specify which question 
should come right after introductory text. For example, the following code will put Question 1 and Question 2 in a sequence while 3 and 4 are shuffled. 
However, Qustions 1 and 2 will not appear right after the Introductory text. In other words, option @[next]@ next to Question 1 has no effect on 
position. Could it be implemented so that specifying @[next]@ as an option for Question 1 results in it always appearing right after Introductory text? 

Thanks,

Niko Z.

@*( Introductory text@

@*[next] Question 1@
@-@
@-@
@+@

@*[next] Question 2@
@-@
@-@
@+@

@* Question 3@
@-@
@-@
@+@

@* Question 4@
@-@
@-@
@+@

@*) Closing text.@
09/15/2013 11:32 pm - Alexis Bienvenüe
With revision r1446, you can use @first@:
<pre>
*( Introductory text

*[first] Question 1
-
-
+

*[first] Question 2
-
-
+

* Question 3
-
-
+

* Question 4
-
-
+

*) Closing text.
</pre>

09/16/2013 06:34 am - Nikola Z. Guscic
I've just tried this, it works well. Thanks for all the new features, together they allow a very fine control of question sequence. I am sure it will be useful 
for many teachers.

09/16/2013 10:35 am - Alexis Bienvenüe
- % Done changed from 0 to 100

- Status changed from New to Resolved

08/19/2014 05:55 am - Anirvan Sarkar
- Assignee set to Alexis Bienvenüe

- Status changed from Resolved to Closed

02/27/2019 11:51 pm - Giovanni Morando
What is the syntax in latex?
I have the graph of a function and 3 questions about it. I want insert the 3 questions right after the graph shuffling them among themselves. The set 
{graph} U {3questions} should be shuffled as a unique object among other questions.
It seems very similar to what has been asked here above but with no first, next or last restrictions (if I understood correctly).

Thanks,
Giovanni

03/08/2019 10:56 am - Alexis Bienvenüe
If @questions@ is your global group of questions, you can use something like:
<pre>
\element{graph}{
  ... question A related to the graph ...
}

\element{graph}{
  ... question B related to the graph ...
}

\setgroupmode{graph}{withoutreplacement}

\element{questions}{
  ... show the graph ...

  \insertgroup{graph}
}
</pre>
